/*============================================================================*
 *  FILE:  
 *     main.c
 *
 *  Description: 
 *     main source code for Palm application.
 *     (This file includes in "skeleton.c".)
 *
 *===========================================================================*/
#define MAIN_C

#include "machine.c"

// external functions
extern Err     OpenForm_NNshMessage (FormType  *frm);
extern void   OpenForm_ThreadMain  (FormType  *frm);
extern void   OpenForm_WriteMessage(FormType  *frm);
extern void   OpenForm_SelectBBS   (FormType  *frm);
extern void   OpenForm_newThread   (FormType  *frm);
extern Err     OpenForm_NNshSetting (FormType  *frm);
extern Err     OpenForm_NNsiSetting2(FormType  *frm);
extern Err     OpenForm_NNsiSetting3(FormType  *frm);
extern Err     OpenForm_NNsiSetting4(FormType  *frm);
extern Err     OpenForm_NNsiSetting5(FormType  *frm);
extern Err     OpenForm_NNsiSetting6(FormType  *frm);
extern Err     OpenForm_NNsiSetting7(FormType  *frm);
extern Err     OpenForm_NNsiSetting8(FormType  *frm);
extern Err     OpenForm_NNsiSetting9(FormType  *frm);
extern Err     OpenForm_NNsiSettingA(FormType  *frm);
extern Err     OpenForm_FavorTabSet (FormType  *frm);
extern Err     OpenForm_NNsiDummy   (FormType  *frm);
extern Err     OpenForm_GetLogList  (FormType  *frm);

extern Boolean Handler_ThreadMain   (EventType *event);
extern Boolean Handler_NNshMessage  (EventType *event);
extern Boolean Handler_WriteMessage (EventType *event);
extern Boolean Handler_SelectBBS    (EventType *event);
extern Boolean Handler_NNshSetting  (EventType *event);
extern Boolean Handler_FavorTabSet  (EventType *event);
extern Boolean Handler_newThread    (EventType *event);
extern Boolean Handler_NNsiDummy    (EventType *event);
extern Boolean Handler_GetLogList   (EventType *event);


/*=========================================================================*/
/*   Function :   MyApplicationDispatchEvent                               */
/*                                                fBXpb`Cxg */
/*=========================================================================*/
static Boolean MyApplicationDispatchEvent(EventType *event)
{
    UInt16 *command;

    //  "n[hL[䂷"@w肪AL[̓CxgȂ
    // tH[̏{
    if (((NNshGlobal->NNsiParam)->useHardKeyControl != 0)&&(event->eType == keyDownEvent))
    {
        if (event->data.keyDown.chr >= vchrHardKeyMin)
        {
            // n[hL[R[h̊mF
            switch (event->data.keyDown.chr)
            {
              case vchrHard1:
                // n[hL[P
                command = &((NNshGlobal->NNsiParam)->useKey.key1);
                break;

              case vchrHard2:
                // n[hL[Q
                command = &((NNshGlobal->NNsiParam)->useKey.key2);
                break;

              case vchrHard3:
                // n[hL[R
                command = &((NNshGlobal->NNsiParam)->useKey.key3);
                break;

              case vchrHard4:
                // n[hL[S
                command = &((NNshGlobal->NNsiParam)->useKey.key4);
                break;

              case vchrCapture:
              case vchrVoiceRec:
              case vchrVZ90functionMenu:      
              case vchrGarminRecord:
              case vchrHard5:
                // CLIE NX Lv`{^ACLIE TG{CXR{^
                command = &((NNshGlobal->NNsiParam)->useKey.clieCapture);
                break;

              case chrLeftArrow:         // J[\L[(5way)
              case vchrRockerLeft:
              case vchrJogLeft:
              case vchrTapWaveSpecificKeyRLeft:
                // n[hL[
                command = &((NNshGlobal->NNsiParam)->useKey.left);
                break;

              case chrRightArrow:     // J[\L[E(5wayE)
              case vchrRockerRight:
              case vchrJogRight:
              case vchrTapWaveSpecificKeyRRight:
                // n[hL[E
                command = &((NNshGlobal->NNsiParam)->useKey.right);
                break;

              case vchrHWKeyboardPush:
                // CLIE n[hL[(Ȃ)
                return (false);
                break;

              default:
                //  imȂjn[hL[͂sꂽƂAL[R[h
                // \
                NNsh_DebugMessage(ALTID_INFO, "Hard Key Event ", " chrID:",
                                  event->data.keyDown.chr);
                return (false);
                break;
            }
            // R}h̔
            switch (*command)
            {
              case HARDKEY_FEATURE_CONTROLNNSI:
                // NNsiŐ(n[hL[ꂽƂ̏s)
                FrmDispatchEvent(event);
                return (true);
                break;

              case HARDKEY_FEATURE_TRANSJOGPUSH:
                // Cxg̃L[R[h𖳗JOG PUSH(LineFeed)ɏ
                event->data.keyDown.chr = chrLineFeed;
                break;

              case HARDKEY_FEATURE_TRANSJOGBACK:
                // Cxg̃L[R[h𖳗JOG BACK(ESC)ɏ
                event->data.keyDown.chr = chrEscape;
                break;

              case HARDKEY_FEATURE_DONOTHING:
              default:
                // Ȃ
                break;
            }
        }
    }
    return (false);
}

/*=========================================================================*/
/*   Function :   MyApplicationHandleEvent                                 */
/*                                                                         */
/*=========================================================================*/
static Boolean MyApplicationHandleEvent(EventType *event)
{
    FormType  *frm;
    TableType *tableP;
    UInt16     rowNum, fieldFont, objFont;

    // SONYVNsꍇ̉ʍXV
    if (NNshGlobal->updateHR == NNSH_UPDATE_DISPLAY)
    {
         // SILK}l[W̕\ɂ킹ʂ̍XVs
        frm = FrmGetActiveForm();
        if (frm != NULL)
        {
            FrmEraseForm(frm);
            NNsi_FrmDrawForm(frm, true);
        }
        NNshGlobal->updateHR = NNSH_NOT_EFFECTIVE;
    }

    // NotifyCxg̎Mʉ߂
    if (NNshGlobal->notifyUpdate != 0)
    {
        frm = FrmGetActiveForm();
        if (frm != NULL)
        {
            switch (NNshGlobal->notifyUpdate)
            {
              case NNSH_VFS_MOUNTED:
                // VFSmountꂽƂ[Uɒʒm
                NNsh_InformMessage(ALTID_WARN, MSG_VFS_MOUNTED, MSG_WARN_VFS_UPDATE, 0);
                break;

              case NNSH_VFS_UNMOUNTED:
                // VFSunmountꂽƂ[Uɒʒm
                NNsh_InformMessage(ALTID_WARN, MSG_VFS_UNMOUNTED, " ", 0);
                break;

              case NNSH_VFS_UNMOUNTED_WRITE:
                // VFSunmountꂽƂ[Uɒʒm
                NNsh_InformMessage(ALTID_WARN, MSG_VFS_UNMOUNTED, MSG_WARN_BACK_THREAD, 0);

                // WRITEʂꗗʂɈړ
                SaveWritingMessage();
                FrmEraseForm(frm);
                FrmGotoForm (NNshGlobal->backFormId);
                break;

              case NNSH_VFS_UNMOUNTED_OTHER:
                // VFSunmountꂽƂ[Uɒʒm
                NNsh_InformMessage(ALTID_WARN, MSG_VFS_UNMOUNTED, MSG_WARN_BACK_THREAD, 0);

                // OɊJĂ(ꗗ or _~[ or QƉ)Ɉړ
                FrmEraseForm(frm);
                FrmGotoForm (ConvertFormID((NNshGlobal->NNsiParam)->lastFrmID));
                break;

              case NNSH_VFS_UNMOUNTED_MESSAGE:
                // VFSunmountꂽƂ[Uɒʒm
                NNsh_InformMessage(ALTID_WARN, MSG_VFS_UNMOUNTED, MSG_WARN_BACK_THREAD, 0);

                // QƉʂꗗʂɈړ
                ReadMessage_Close(NNshGlobal->backFormId);
                break;

              case NNSH_DISP_RESIZED:
                // ʂ̃TCYύXɂȂ...
                HandEraResizeForm(frm);
                UpdateFieldRegion();
                NNsh_DebugMessage(ALTID_INFO, "[[<<DISPLAY RESIZED>>]]", "", 0);

                FrmEraseForm(frm);
                NNsi_FrmDrawForm(frm, true);
                break;

              default:
                break;
            }
        }
        NNshGlobal->notifyUpdate = 0;
    }

    // ŁA(tH[[h)CxgM̏LqB
    switch (event->eType)
    {
      // tH[Jevent
      case frmLoadEvent:
        // gptHgݒ肷
        fieldFont = (NNshGlobal->NNsiParam)->currentFont;
        FntSetFont(fieldFont);
        objFont   = (NNshGlobal->NNsiParam)->currentFont;

        // tH[ 
        frm = FrmInitForm(event->data.frmLoad.formID);
#ifdef USE_HANDERA
        if (NNshGlobal->device == NNSH_DEVICE_HANDERA)
        {
            VgaFormModify(frm, vgaFormModify160To240);
        }
#endif
#ifdef USE_PIN_DIA
        if (NNshGlobal->device == NNSH_DEVICE_DIASUPPORT)
        {
            VgaFormModify_DIA(frm, vgaFormModifyNormalToWide);
        }
        else if (NNshGlobal->device == NNSH_DEVICE_GARMIN)
        {
            // ʂI[vƂ́Aĕ`悷(Garmin@)
            VgaFormModify_DIA(frm, vgaFormModifyNormalToWide);
            NNshGlobal->notifyUpdate = NNSH_DISP_RESIZED;
            EvtWakeup();
        }
#endif

#ifdef USE_MACRO
        if (NNshGlobal->tempStatus != NNSH_MACROCMD_EXECUTE)
        {
            NNshGlobal->tempStatus = 0;
        }
#else
        NNshGlobal->tempStatus = 0;
#endif

        // tH[JăCxgnhݒ肷
        FrmSetActiveForm(frm);
        switch (event->data.frmLoad.formID)
        {
          // Xꗗ
          case FRMID_THREAD:
            // OtBeBGAŏĉʂTCYAtHgύX
            (void) NNshSilkMinimize(frm);

            // tH[JāACxgnhݒ肷
            OpenForm_ThreadMain(frm);
            FrmSetEventHandler(frm, Handler_ThreadMain);

            // OpenForm_ThreadMain()ŉʂ`悷邽߁Aɔ
            return (true);
            break;

          // XQƉ
          case FRMID_MESSAGE:
            // OtBeBGAŏĉʂTCYAtHgύX
            (void) NNshSilkMinimize(frm);
            FldSetFont(FrmGetObjectPtr(frm, 
                            FrmGetObjectIndex(frm, FLDID_MESSAGE)), fieldFont);
#ifdef USE_GLUE
            CtlGlueSetFont(FrmGetObjectPtr(frm,
                       FrmGetObjectIndex(frm, SELTRID_THREAD_TITLE)), objFont);
#endif
            // tH[JāACxgnhݒ肷
            OpenForm_NNshMessage(frm);
            FrmSetEventHandler(frm, Handler_NNshMessage);

            // OpenForm_NNshMessage()ŉʂ`悷邽߁Aɔ
            return (true);
            break;
 
          // X݉
          case FRMID_WRITE_MESSAGE:
            // OtBeBGAő剻ĉʂTCYAtHgύX
            FldSetFont(FrmGetObjectPtr(frm,
                         FrmGetObjectIndex(frm, FLDID_WRITE_NAME)), fieldFont);
            FldSetFont(FrmGetObjectPtr(frm, 
                        FrmGetObjectIndex(frm, FLDID_WRITE_EMAIL)), fieldFont);
            FldSetFont(FrmGetObjectPtr(frm, 
                      FrmGetObjectIndex(frm, FLDID_WRITE_MESSAGE)), fieldFont);
            if ((NNshGlobal->NNsiParam)->notOpenSilkWrite == 0)
            {
                (void) NNshSilkMaximize(frm);
            }
            else
            {
                (void) NNshSilkMinimize(frm);
            }

            // tH[JāACxgnhݒ肷
            OpenForm_WriteMessage(frm);
            FrmSetEventHandler(frm, Handler_WriteMessage);
            break;

          // BBSǗ
          case FRMID_MANAGEBBS:
            // OtBeBGAŏĉʂTCY
            if (NNshSilkMinimize(frm) == errNone)
            {
                // CLIE UXȊÔƂ͊gAAAi[x^AAAj
#ifdef USE_CLIE
                if (NNshGlobal->silkVer != 3)
#endif
                {
                    // ̈TCY߂
                    tableP = FrmGetObjectPtr(frm, 
                                   FrmGetObjectIndex(frm, TBLID_BBS_SELECTION));
                    for (rowNum = 0;
                         rowNum < TblGetNumberOfRows(tableP); rowNum++)
                    {
                        TblSetRowHeight(tableP, rowNum, 15);
                    }
                }
            }
            // tH[JāACxgnhݒ肷
            OpenForm_SelectBBS(frm);
            FrmSetEventHandler(frm, Handler_SelectBBS);
            break;

          // NNsiݒ
          case FRMID_CONFIG_NNSH:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNshSetting(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-2
          case FRMID_NNSI_SETTING2:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting2(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-3
          case FRMID_NNSI_SETTING3:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting3(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-4
          case FRMID_NNSI_SETTING4:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting4(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-5
          case FRMID_NNSI_SETTING5:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting5(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-6
          case FRMID_NNSI_SETTING6:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting6(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-7
          case FRMID_NNSI_SETTING7:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting7(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-8
          case FRMID_NNSI_SETTING8:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting8(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ-9
          case FRMID_NNSI_SETTING9:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSetting9(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // NNsiݒ(T)
          case FRMID_NNSI_SETTING_ABSTRACT:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_NNsiSettingA(frm);
            FrmSetEventHandler(frm, Handler_NNshSetting);
            break;

          // Cɓݒ
          case FRMID_FAVORSET_DETAIL:
            // OtBeB̈ő剻AtH[JăCxgnhݒ
            (void) NNshSilkMaximize(frm);
            OpenForm_FavorTabSet(frm);
            FrmSetEventHandler(frm, Handler_FavorTabSet);
            break;

          // NNsiN(DUMMY)
          case FRMID_NNSI_DUMMY:
            // OtBeBGAŏĉʂTCYAtHgύX
            (void) NNshSilkMinimize(frm);
            OpenForm_NNsiDummy(frm);
            FrmSetEventHandler(frm, Handler_NNsiDummy);
            break;

          // Xĉ
          case FRMID_NEW_THREAD:
            // OtBeBGAő剻ĉʂTCYAtHgύX
            FldSetFont(FrmGetObjectPtr(frm,
                         FrmGetObjectIndex(frm, FLDID_WRITE_NAME)), fieldFont);
            FldSetFont(FrmGetObjectPtr(frm, 
                        FrmGetObjectIndex(frm, FLDID_WRITE_EMAIL)), fieldFont);
            FldSetFont(FrmGetObjectPtr(frm, 
                      FrmGetObjectIndex(frm, FLDID_NEWTHREAD_TITLE)), fieldFont);
            FldSetFont(FrmGetObjectPtr(frm, 
                      FrmGetObjectIndex(frm, FLDID_NEWTHREAD_MESSAGE)), fieldFont);
            if ((NNshGlobal->NNsiParam)->notOpenSilkWrite == 0)
            {
                (void) NNshSilkMaximize(frm);
            }
            else
            {
                (void) NNshSilkMinimize(frm);
            }

            // tH[JāACxgnhݒ肷
            OpenForm_newThread(frm);
            FrmSetEventHandler(frm, Handler_newThread);
            break;

#ifdef USE_LOGCHARGE
          // QƃOꗗ
          case FRMID_LISTGETLOG:
            // OtBeBGAŏĉʂTCYAtHgύX
            (void) NNshSilkMinimize(frm);
            OpenForm_GetLogList(frm);
            FrmSetEventHandler(frm, Handler_GetLogList);

            // OpenForm_GetLogList()ŉʂ`悷邽߁Aɔ
            return (true);
            break;
#endif // #ifdef USE_LOGCHARGE

          default:
            // "tH[JCxg"\Ă݂B(fobO)
            NNsh_DebugMessage(ALTID_INFO, "frmLoadEvent()", " formID:",
                              event->data.frmLoad.formID);
            break;
        }
        // ʂ`悷
        NNsi_FrmDrawForm(frm, true);
        break;

#ifdef USE_PIN_DIA
      case winEnterEvent:
        if ((NNshGlobal->device == NNSH_DEVICE_DIASUPPORT)||
            (NNshGlobal->device == NNSH_DEVICE_GARMIN))
        {
            frm = FrmGetActiveForm();

            // ʂ`悳ꂽƂAVNŏ/ő剻Lɂ
            if (event->data.winEnter.enterWindow == FrmGetWindowHandle(frm))
            {
                PINSetInputTriggerState(pinInputTriggerEnabled);
            }
        }
        break;
#endif  // #ifdef USE_PIN_DIA
#if 0
      // tH[Jevent
      case frmOpenEvent:
        break;

      // tH[event
      case frmCloseEvent:
        break;
#endif
      default:
        // T|[gĂȂCxgMB
        break;
    }
    return (false);
}

/*=========================================================================*/
/*   Function :   MyApplicationHandleNotifications                         */
/*                                Notification                         */
/*=========================================================================*/
static UInt32  MyApplicationHandleNotifications(SysNotifyParamType *notifyParamsP)
{ 
  // PilotMainĂCode Resourcȅꍇ͂Notification̂ʓI
  // ĂȂꍇSysNotifyRegisterfunction pointernĂ

  switch(notifyParamsP->notifyType)
  {
    case sysNotifyVolumeUnmountedEvent:
        VFSUnmountNotify(notifyParamsP);
        break;

    case sysNotifyVolumeMountedEvent:
        VFSMountNotify(notifyParamsP);
        break;     
  }
  
  return 0;
}

/*=========================================================================*/
/*   Function :   myStartApplication                                       */
/*                                 X^[g(vO)  */
/*=========================================================================*/
static UInt16 MyStartApplication(UInt16 cmd, void *cmdPBP, UInt16 launchFlags)
{
    Int16                   ret;
    UInt16                  size;
    NNshSoftwareVersionInfo verInfo;
#ifdef USE_ARMLET
    UInt32                  processorType;
#endif
    UInt32                  osVersion;
#ifdef USE_TSPATCH
    UInt32                  fontId, fontVer;
#endif    

    // r[Mo^...
    ExgRegisterData(SOFT_CREATOR_ID, exgRegExtensionID, NNSI_EXCHANGEINFO_SUFFIX); 

    // NNsiݒo[W̊mF
    //   (VersionmFpPreferencemFAύXȂΕ)
    size = sizeof(NNshSoftwareVersionInfo);
    MemSet(&verInfo, sizeof(NNshSoftwareVersionInfo), 0x00);
    ret  = PrefGetAppPreferences(SOFT_CREATOR_ID, SOFT_PREFID, 
                                 &verInfo, &size, false);
    if (ret == noPreferenceFound)
    {
        //  preference݂Ȃꍇɂ́Ao[Wԍ
        // NNsiݒ̃TCY͐̂ƂďB
        ret              = SOFT_PREFVERSION;
        verInfo.prefSize = sizeof(NNshSavedPref);
    }

    // NNsiO[öpi[̈̊m
    size       = sizeof(NNshWorkingInfo) + MARGIN;
    NNshGlobal = (NNshWorkingInfo *) MEMALLOC_PTR(size);
    if (NNshGlobal == NULL)
    {
        // ̈mۂɎsI(NNsi͋NȂ)
        NNsh_ErrorMessage(ALTID_ERROR, MSG_NNSI_CANNOT_LAUNCH,
                          "(NNsiGbl)\nsize:", size);
        return (0);
    }        
    MemSet (NNshGlobal, size, 0x00);
    StrCopy(NNshGlobal->dummyBuffer, " ");

    // J́AXꗗʂɖ߂悤ɂB
    //   
    //    QƃOꗗQƉʂŊJƁANNsiċNĖ߂ƁA
    //   ̂܂܂ƁAʏ̈ꗗʂɑJڂĂ܂B
    NNshGlobal->backFormId = FRMID_THREAD;

    // NNsiݒpi[̈̊m
    size = sizeof(NNshSavedPref) + DBSIZE_SETTING;
    (NNshGlobal->NNsiParam) = (NNshSavedPref *) MEMALLOC_PTR(size);
    if ((NNshGlobal->NNsiParam) == NULL)
    {
        // ̈mۂɎsI(NNsi͋NȂ)
        NNsh_ErrorMessage(ALTID_ERROR, MSG_NNSI_CANNOT_LAUNCH,
                          "(NNsiSet)\nsize:", size);
        return (0);
    }
    MemSet((NNshGlobal->NNsiParam), size, 0x00);

    // OSo[W̊mF
    if (FtrGet(sysFtrCreator, sysFtrNumROMVersion, &osVersion) == errNone)
    {
        NNshGlobal->palmOSVersion = osVersion;
    }

    // NNsiݒ𕜋
    (void) NNshRestoreNNsiSetting(ret, verInfo.prefSize, (NNshGlobal->NNsiParam));

    // fobO[h̏𕜋
    (NNshGlobal->NNsiParam)->debugMessageON = verInfo.debugMode;

    // VFS@\Ȃݒ肾ꍇɂ́AUVFSp[^NAB
    if ((NNshGlobal->NNsiParam)->useVFS == NNSH_NOTSUPPORT_VFS)
    {
        (NNshGlobal->NNsiParam)->useVFS = NNSH_VFS_DISABLE;
    }
    // VFST|[g̐ݒ
    checkVFSdevice_NNsh();

    // VFS ɃobNAbvꂽDB΁ARs[邩ǂ
    if (((NNshGlobal->NNsiParam)->useVFS & (NNSH_VFS_ENABLE | NNSH_VFS_DBIMPORT)) ==
        (NNSH_VFS_ENABLE | NNSH_VFS_DBIMPORT))
    {
        UInt16 backup;
        
        backup = (NNshGlobal->NNsiParam)->confirmationDisable;
        (NNshGlobal->NNsiParam)->confirmationDisable = NNSH_OMITDIALOG_NOTHING;

        // VFS  DB Rs[
        RestoreDBtoVFS(false);
        if (NNshGlobal->restoreSetting)
        {
            // NNsiݒ𕜋
            (void) NNshRestoreNNsiSetting(ret, verInfo.prefSize, (NNshGlobal->NNsiParam));
        }
        else
        {
            (NNshGlobal->NNsiParam)->confirmationDisable = backup;
        }
    }

#ifdef USE_CLIE
    // Silk̐ݒ𔽉f
    NNshGlobal->notUseSilk = (NNshGlobal->NNsiParam)->notUseSilk;

    // CLIET|[g̐ݒ
    setCLIESupport_NNsh();
#endif  // #ifdef USE_CLIE

#ifdef USE_HANDERA
    // HandEraT|[g̐ݒ
    setHandEraSupport_NNsh();
#endif // #ifdef USE_HANDERA

#ifdef USE_PIN_DIA
    // pen input manager̐ݒ
    setDIASupport_NNsh();
#endif    // #ifdef USE_PIN_DIA

#ifdef USE_HIGHDENSITY
    // 𑜓xT|[g/J[T|[g̃`FbN
    setDoubleDensitySupport_NNsh();
#else
    // 𑜓xT|[gݒ
    NNshGlobal->os5HighDensity = (UInt32) kDensityLow;
#endif    // #ifdef USE_HIGHDENSITY

#ifdef USE_TSPATCH
    // TsPatchΉR[h...(TsPatchKpǂ`FbN)
    if ((NNshGlobal->NNsiParam)->notUseTsPatch == 0)
    {
        ret = FtrGet(SmallFontAppCreator, SMF_FTR_SMALL_FONT_SUPPORT, &fontVer);
        if (ret == errNone)
        {    
            // TsPatchKp...gptHgB
            switch ((NNshGlobal->NNsiParam)->currentFont)
            {
              case stdFont:
                FtrGet(SmallFontAppCreator, SMF_FTR_TINY_FONT, &fontId);
                break;

              case boldFont:
                FtrGet(SmallFontAppCreator, SMF_FTR_TINY_BOLD_FONT, &fontId);
                break;

              case largeFont:
                FtrGet(SmallFontAppCreator, SMF_FTR_SMALL_FONT, &fontId);
                break;

              case largeBoldFont:
                FtrGet(SmallFontAppCreator, SMF_FTR_SMALL_BOLD_FONT, &fontId);
                break;

              default:
                fontId = (NNshGlobal->NNsiParam)->currentFont;
                break;
            }
            (NNshGlobal->NNsiParam)->currentFont = fontId;
        }
    }
    else
    {
        // TsPatch@\gȂꍇ,,,
        switch ((NNshGlobal->NNsiParam)->currentFont)
        {
          case stdFont:
          case boldFont:
          case largeFont:
          case largeBoldFont:
            // ̂܂܎g
            break;

          default:
            // WtHgɕύX
            (NNshGlobal->NNsiParam)->currentFont = stdFont;
            break;
        }
    }
#endif  // #ifdef USE_TSPATCH


#ifdef USE_ARMLET
    // ARMletgpۂ̃`FbN
    FtrGet(sysFileCSystem, sysFtrNumProcessorID, &processorType);
    if (sysFtrNumProcessorIsARM(processorType))
    {
        // ARMletgp\foCXB
        // (NNshGlobal->NNsiParam)->useARMlet = NNSH_ENABLE;  // ARMlet͎gpݒɕύX
    }
    else
#endif
    {
        // ARMlet͎gpȂݒɂ
        (NNshGlobal->NNsiParam)->useARMlet = NNSH_DISABLE;
    }

    // WebBrowser̃CXg[`FbN
    checkInstalledWebBrowser();

    // ݒ肳Ăꍇ
    if ((NNshGlobal->NNsiParam)->useBookmark != 0)
    {
        // ݒL̈mۂ
        NNshGlobal->bookmarkFileName = MEMALLOC_PTR(MAX_THREADFILENAME);
        if (NNshGlobal->bookmarkFileName != NULL)
        {
            NNshGlobal->bookmarkNick = MEMALLOC_PTR(MAX_NICKNAME);
            if (NNshGlobal->bookmarkNick == NULL)
            {
                MEMFREE_PTR(NNshGlobal->bookmarkFileName);
            }
        }
        if ((NNshGlobal->NNsiParam)->lastFrmID == NNSH_FRMID_MESSAGE)
        {
            // 肪ݒ肳Ăꍇɂ́AJꏊw
            if ((NNshGlobal->NNsiParam)->bookMsgNumber != 0)
            {
                (NNshGlobal->NNsiParam)->openMsgIndex = (NNshGlobal->NNsiParam)->bookMsgIndex;
            }
        }
    }

    // NGݒ̕`FbN
    if ((NNshGlobal->NNsiParam)->useRegularExpression != 0)
    {
        SeparateWordList((NNshGlobal->NNsiParam)->hideWord1, &(NNshGlobal->hide1));
        SeparateWordList((NNshGlobal->NNsiParam)->hideWord2, &(NNshGlobal->hide2));
    }

    // ^CgR[h̎w肪ُ̏ꍇAR[hԍ
    if (((NNshGlobal->NNsiParam)->startTitleRec == (NNshGlobal->NNsiParam)->endTitleRec)&&
        ((NNshGlobal->NNsiParam)->startTitleRec == 0))
    {
        (NNshGlobal->NNsiParam)->startTitleRec = 0xffff;
    }

    // NɋN[hݒ肳ĂꍇA_~[ʂJ
    if (StrLen((NNshGlobal->NNsiParam)->launchPass) != 0)
    {
        return (FRMID_NNSI_DUMMY);
    }

    // VFSOFFꍇɂ́AmFbZ[W\B
    if ((NNshGlobal->NNsiParam)->useVFS == NNSH_VFS_DISABLE)
    {
        NNsh_WarningMessage(ALTID_WARN, MSG_USE_VFS_WARNING1,
                            MSG_USE_VFS_WARNING2, 0);
    }

    // ZLIB̃T|[gۊmFs
    SetZLIBsupport_NNsh();
        
#ifdef USE_MACRO
    // N1񂾂s}N݂ꍇAAA
    if (DmFindDatabase(0, DBNAME_RUNONCEMACRO) != 0)
    {
        NNshGlobal->tempStatus = NNSH_MACROCMD_OPERATE;
        return (FRMID_THREAD);
    }

    // }N̎sݒ肳Ăꍇɂ́AꗗʂJ
    if ((NNshGlobal->NNsiParam)->autostartMacro != 0)
    {
        NNshGlobal->tempStatus = NNSH_MACROCMD_EXECUTE;
        return (FRMID_THREAD);
    }
#endif

    // ŏɃI[vtH[IDB
    return (ConvertFormID((NNshGlobal->NNsiParam)->lastFrmID));
}

/*=========================================================================*/
/*   Function :   myStopApplication                                        */
/*                                 Xgbv(vO)  */
/*=========================================================================*/
static void MyStopApplication(void)
{
    UInt16                  savedParam, frmId;
    NNshSoftwareVersionInfo verInfo;

    frmId = FrmGetActiveFormID();
    switch (frmId)
    {
      case FRMID_WRITE_MESSAGE:
        //  ݉ʂŃAv悤Ƃꍇ
        // (ݓeۑ邩mF)
        SaveWritingMessage();
        break;
      case FRMID_MESSAGE:
        //  QƃOꗗʂJXQƒ̏ꍇɂ́A
        // N̓XQƉʂJ悤ɂB(̍...)
        if (NNshGlobal->backFormId == FRMID_LISTGETLOG)
        {
            if (((NNshGlobal->NNsiParam)->useBookmark != 0)&&
                 ((NNshGlobal->NNsiParam)->bookMsgNumber != 0))
            {
                // ݒ蒆Ȃ̂ŁAȂ
            }
            else
            {
                (NNshGlobal->NNsiParam)->lastFrmID = NNSH_FRMID_GETLOGLIST;
            }
        }
        break;

      default:
        break;
    }

    // VFS Notification̉
    resetVFSNotifications();

    // NNsiݒVersionmFpPreference̕ۑ(Debug[h͂ŋL)
    verInfo.NNsiVersion = SOFT_PREFVERSION;
    verInfo.prefSize    = sizeof(NNshSavedPref);
    verInfo.prefType    = NNSH_PREFERTYPE;
    verInfo.debugMode   = ((NNshGlobal->NNsiParam) != NULL) ? (NNshGlobal->NNsiParam)->debugMessageON : 0;
    PrefSetAppPreferences(SOFT_CREATOR_ID, SOFT_PREFID, SOFT_PREFVERSION,
                          &verInfo, sizeof(NNshSoftwareVersionInfo), false);

    // NNsĩO[ö悪mۂĂȂƂ͏I
    if (NNshGlobal == NULL)
    {
        return;
    }

    // X^Cg\폜(ꗗ)
    ClearMsgTitleInfo();

#ifdef USE_CLIE
    // CLIET|[gJ
    resetCLIESupport_NNsh();
#endif

    // NNsiݒ̕ۑ(NNsi̋Nɐ̂)
    if ((NNshGlobal->NNsiParam) != NULL)
    {
        // e|t@C̍폜(DEBUG[hɂ͎cĂ)
        if ((NNshGlobal->NNsiParam)->debugMessageON == 0)
        {
            (void) DeleteFile_NNsh(FILE_SENDMSG, NNSH_VFS_DISABLE);
            (void) DeleteFile_NNsh(FILE_RECVMSG, NNSH_VFS_DISABLE);
        }

        // NNsiIɉؒf
        if ((NNshGlobal->NNsiParam)->disconnectNNsiEnd != 0)
        {
            // vOIɂ́Auؒfv̊mFbZ[W͏oȂB
            savedParam = (NNshGlobal->NNsiParam)->confirmationDisable;
            (NNshGlobal->NNsiParam)->confirmationDisable = NNSH_OMITDIALOG_ALLOMIT;
            NNshNet_LineHangup();
            (NNshGlobal->NNsiParam)->confirmationDisable = savedParam;
        }

        // Silk̐ݒ𔽉f
#ifdef USE_CLIE
        if ((NNshGlobal->NNsiParam)->notUseSilk != NNshGlobal->notUseSilk)
        {
            (NNshGlobal->NNsiParam)->notUseSilk = NNshGlobal->notUseSilk;
        }
#endif  // #ifdef USE_CLIE
        NNshSaveNNsiSetting(NNSH_PREFERTYPE, sizeof(NNshSavedPref), (NNshGlobal->NNsiParam));

        // NNsiIɃf[^x[XVFSɃobNAbv
        if (((NNshGlobal->NNsiParam)->useVFS & (NNSH_VFS_DBBACKUP)) != 0)
        {
            BackupDBtoVFS(NNSH_DISABLE);
        }

        // uݒvݒ蒆̏ꍇ
        if (((NNshGlobal->NNsiParam)->useBookmark != 0)&&
            ((NNshGlobal->NNsiParam)->bookMsgNumber != 0)&&
            (NNshGlobal->bookmarkFileName != NULL))
        {
            // ݒ(indexԍ)L
            (void) GetSubjectIndex(NNshGlobal->bookmarkNick,
                                    NNshGlobal->bookmarkFileName,
                                    &((NNshGlobal->NNsiParam)->bookMsgIndex));
        }
    }

    // NNsiO[öi̒gjJ
    NNshClearGlobal(NNshGlobal);

    // NNsiݒ̎gp̈J
#ifdef RELEASE_NNSISETTING
    //MEMFREE_PTR((NNshGlobal->NNsiParam));
    MemPtrFree((NNshGlobal->NNsiParam));
#endif

    // NNsĩO[öJ
#ifdef RELEASE_NNSIGLOBAL
    // MEMFREE_PTR(NNshGlobal);
    MemPtrFree(NNshGlobal);
#endif

    return;
}

/*=========================================================================*/
/*   Function : MyApplicationReceiveData                                   */
/*                            Exchange}l[Wgpăf[^M */
/*=========================================================================*/
UInt32 MyApplicationReceiveData(void *cmdPBP, UInt16 launchFlags)
{
    ExgSocketType      *exgSocket;
    NNshGetLogDatabase *logP;
    Err                 err;
    UInt8              *dbName, *token, entried;
    UInt8              *buff, *ptr, *data;
    UInt16              len;
    UInt32              size, ret;
    MemHandle           strH;
    DmOpenRef           dbRef;

    // AvP[VNǂmFtO
    entried    = 0;

    // Mf[^TCY̊m
    exgSocket = (ExgSocketType *) cmdPBP;
    size = (BUFSIZE > exgSocket->length) ? BUFSIZE : exgSocket->length;

    buff = MEMALLOC_PTR(size + MARGIN);
    if (buff == NULL)
    {
        // G[...
        return (false);
    }
    MemSet(buff, (size + MARGIN), 0x00);
    
    // DB̈̊m
    dbName = MEMALLOC_PTR(BUFSIZE + MARGIN);
    if (dbName == NULL)
    {
        MEMFREE_PTR(buff);
        return (false);
    }
    MemSet(dbName, (BUFSIZE + MARGIN), 0x00);

    // g[N̈̊m
    token = MEMALLOC_PTR(BUFSIZE + MARGIN);
    if (token == NULL)
    {
        MEMFREE_PTR(dbName);
        MEMFREE_PTR(buff);
        return (false);
    }
    MemSet(dbName, (BUFSIZE + MARGIN), 0x00);

    // QƃOpcamۂ
    logP = MEMALLOC_PTR(sizeof(NNshGetLogDatabase) + MARGIN);
    if (logP == NULL)
    {
        MEMFREE_PTR(token);
        MEMFREE_PTR(dbName);
        MEMFREE_PTR(buff);
        return (false);
    }
    
    // Mf[^̎󂯕t
    err = ExgAccept(exgSocket);
    if (err != errNone)
    {
        // Ms...
        goto FUNC_END;
    }

    // f[^ɓB܂ŎM
    ptr = buff;
    while (1)
    {
        ret = ExgReceive(exgSocket, ptr, size, &err);
        if ((ret == 0)||(err == exgErrUserCancel)||(err == exgErrNotSupported))
        {
            // ]IA̓G[IȂ̂Ŕ
            break;
        }

        // f[^̊mF
        MemSet(token, sizeof(token), 0x00);
        strH = DmGetResource('tSTR', NNSI_STRINGTAG_START_NNSIEXT_THREADNUMBER);
        if (strH != 0)
        {
            StrCopy(token, MemHandleLock(strH));
            MemHandleUnlock(strH);
        }
        else
        {
            token[0] = '<';
            token[1] = 'N';
            token[2] = 'N';
            token[3] = 's';
            token[4] = 'i';
            token[5] = ':';
        }
        data = StrStr(ptr, token);
        if (data != NULL)
        {
            // Xԍ̒o
            data = data + 28; // 28́AStrLen(NNSI_NNSIEXT_THREADNUMBER_START);
            ptr = data;
            while ((*ptr != '<')&&(*ptr != '\0'))
            {
                ptr++;
            }
            *ptr = '\0';

            // DBo^
            MemSet(dbName, sizeof(dbName), 0x00);
            dbName[0] = 'G';
            dbName[1] = 'e';
            dbName[2] = 't';
            dbName[3] = 'R';
            dbName[4] = 'e';
            dbName[5] = 's';
            dbName[6] = 'e';
            dbName[7] = 'r';
            dbName[8] = 'v';
            dbName[9] = 'e';
            dbName[10] = '-';
            dbName[11] = 'N';
            dbName[12] = 'N';
            dbName[13] = 's';
            dbName[14] = 'i';

            // Xԍo^...
            //  (OpenDatabase_NNsh(dbName,DBVERSION_GETRESERVE,&dbRef); Ɠ)
           {
                LocalID dbId;

                dbRef = 0;
                dbId  = DmFindDatabase(0, dbName);
                if (dbId == 0)
                {
                    // f[^x[XVK쐬
                    (void) DmCreateDatabase(0, dbName, 
                                       SOFT_CREATOR_ID, SOFT_DBTYPE_ID, false);
                    dbId      = DmFindDatabase(0, dbName);
                    if (dbId != 0)
                    {
                        UInt16 dbVersion;
                        dbVersion = DBVERSION_GETRESERVE;
                        (void) DmSetDatabaseInfo(0, dbId, NULL,NULL, 
                                                      &dbVersion, NULL,
                                                      NULL,NULL,NULL,NULL,
                                                      NULL,NULL,NULL);
                    }
                }

                if (dbId != 0)
                {
                    dbRef = DmOpenDatabase(0 , dbId, dmModeReadWrite);
                }
            }
            if (dbRef != 0)
            {
                // caɓo^
                // (void) EntryRecord_NNsh(dbRef, BUFSIZE, data); Ɠ
                {
                        MemHandle  newRecH;
                        UInt16     index;

                        // R[h̐VKǉ
                        index   = 0;
                        newRecH = DmNewRecord(dbRef, &index, 
                                                    BUFSIZE + sizeof(UInt32));
                        if (newRecH != 0)
                        {
                            // R[hɃf[^
                            DmWrite(MemHandleLock(newRecH), 0, data, BUFSIZE);
                            MemHandleUnlock(newRecH);

                            // R[hiύXIj
                            DmReleaseRecord(dbRef, index, true);
                        }
                }
                // CloseDatabase_NNsh(dbRef); Ɠ
                {
                    DmCloseDatabase(dbRef);
                    dbRef = 0;
                }
                entried = 1;
            }
        }
        else
        {
            // DBo^
            MemSet(dbName, sizeof(dbName), 0x00);
            dbName[0] = 'L';
            dbName[1] = 'o';
            dbName[2] = 'g';
            dbName[3] = 'P';
            dbName[4] = 'e';
            dbName[5] = 'r';
            dbName[6] = 'm';
            dbName[7] = 'a';
            dbName[8] = 'n';
            dbName[9] = 'e';
            dbName[10] = 'n';
            dbName[11] = 't';
            dbName[12] = '-';
            dbName[13] = 'N';
            dbName[14] = 'N';
            dbName[15] = 's';
            dbName[16] = 'i';

            // f[^̐擪...
            MemSet(token, sizeof(token), 0x00);
            strH = DmGetResource('tSTR', NNSI_STRINGTAG_START_NNSIEXT_URL);
            if (strH != 0)
            {
                StrCopy(token, MemHandleLock(strH));
                MemHandleUnlock(strH);
            }
            else
            {
                token[0] = '<';
                token[1] = 'N';
                token[2] = 'N';
                token[3] = 's';
                token[4] = 'i';
                token[5] = ':';
            }

            // URL̊mF
            data = StrStr(ptr, token);
            if (data != NULL)
            {
                // URL̒o
                data = data + 25; // 25́AStrLen(NNSI_NNSIEXT_URL_START);

                MemSet(token, sizeof(token), 0x00);
                strH = DmGetResource('tSTR', NNSI_STRINGTAG_END);
                if (strH != 0)
                {
                    StrCopy(token, MemHandleLock(strH));
                    MemHandleUnlock(strH);

                    // f[^̖T
                    ptr = StrStr(data, token);
                    if (ptr != NULL)
                    {
                        *ptr = '\0';
                    }
                }

                // URLQƃOpDBɓo^...
                // OpenDatabase_NNsh(dbName, DBVERSION_PERMANENTLOG, &dbRef);
                {
                    LocalID dbId;

                    dbRef = 0;
                    dbId  = DmFindDatabase(0, dbName);
                    if (dbId == 0)
                    {
                        // f[^x[XVK쐬
                        (void) DmCreateDatabase(0, dbName, 
                                       SOFT_CREATOR_ID, SOFT_DBTYPE_ID, false);
                        dbId      = DmFindDatabase(0, dbName);
                        if (dbId != 0)
                        {
                            UInt16 dbVersion;
                            dbVersion = DBVERSION_PERMANENTLOG;
                            (void) DmSetDatabaseInfo(0, dbId, NULL,NULL, 
                                                      &dbVersion, NULL,
                                                      NULL,NULL,NULL,NULL,
                                                      NULL,NULL,NULL);
                        }
                    } 
                    if (dbId != 0)
                    {
                        dbRef = DmOpenDatabase(0 , dbId, dmModeReadWrite);
                    }
                }
                if (dbRef != 0)
                {
                    // f[^̈̏
                    MemSet(logP, (sizeof(NNshGetLogDatabase) + MARGIN), 0x00);

                    // AhX(URL)o
                    ptr = logP->dataURL;
                    len = 0;
                    while ((*data != '"')&&(len < MAX_GETLOG_URL))
                    {
                        *ptr = *data;
                        ptr++;
                        data++;
                        len++;
                    }
                    data++;

                    // ^Cg𒊏o
                    ptr = logP->dataTitle;
                    len = 0;
                    while ((*data != '\0')&&(*data != '"')&&(len < MAX_TITLE_LABEL))
                    {
                        *ptr = *data;
                        ptr++;
                        data++;
                        len++;
                    }

                    // QƃÔcaɓo^
                    // EntryRecord_NNsh(dbRef,sizeof(NNshGetLogDatabase),logP);
                    {
                        MemHandle  newRecH;
                        UInt16     index;

                        // R[h̐VKǉ
                        index   = 0;
                        newRecH = DmNewRecord(dbRef, &index, 
                                 sizeof(NNshGetLogDatabase) + sizeof(UInt32));
                        if (newRecH != 0)
                        {
                            // R[hɃf[^
                            DmWrite(MemHandleLock(newRecH), 0, logP,
                                                   sizeof(NNshGetLogDatabase));
                            MemHandleUnlock(newRecH);

                            // R[hiύXIj
                            DmReleaseRecord(dbRef, index, true);
                        }
                    }
                    // CloseDatabase_NNsh(dbRef);
                    {
                        DmCloseDatabase(dbRef);
                        dbRef = 0;
                    }
                    entried = 2;
                }
            }
        }
        ptr = buff;
    }
    // ؒf
    err = ExgDisconnect(exgSocket, err);

FUNC_END:
    // URLM̏_CAO
    if (entried == 2)
    {
        strH = DmGetResource('tSTR', MSG_ENTRIED_URL);
        if (strH != 0)
        {
            // URLMƂ̃_CAO\
            FrmCustomAlert(ALTID_WARN, MemHandleLock(strH), "", "");
        }
        MemHandleUnlock(strH);
    }
    
    // XԍM̏_CAO
    if (entried == 1)
    {
        strH = DmGetResource('tSTR', MSG_ENTRIED_THREADNUMBER);
        if (strH != 0)
        {
            // XԍMƂ̃_CAO\
            FrmCustomAlert(ALTID_WARN, MemHandleLock(strH), "", "");
        }
        MemHandleUnlock(strH);
    }

    // ̈̊J
    MEMFREE_PTR(token);
    MEMFREE_PTR(dbName);
    MEMFREE_PTR(logP);
    MEMFREE_PTR(buff);
    return (false);
}

/*=========================================================================*/
/*   Function :   checkLaunchCode                                          */
/*                                                       NR[h̊mF  */
/*=========================================================================*/
Boolean checkLaunchCode(UInt16 cmd, void *cmdPBP, UInt16 launchFlags)
{
    switch (cmd)
    {
      default:
        // NR[h̃`FbN...
        break;
    }

    // ȊŐNR[h...

    // Ƃ肠́Ar[Mo^...
    ExgRegisterData(SOFT_CREATOR_ID, exgRegExtensionID, NNSI_EXCHANGEINFO_SUFFIX); 
    return (false);
}
